local i,e,a
require"luci.util"
local o=require"nixio.fs"
local t=require"luci.sys"
local t=luci.util.split(luci.util.trim(t.exec("/usr/libexec/fan-control get 2>/dev/null"))," ")
if#t<3 then
return
end
i=Map("luci-fan",translate("Fan Control"),translate("Control fan start and stop temperature. This plugin can only configure the lowest gear, not necessarily applicable to all devices."))
e=i:section(SimpleSection)
e.template="luci-fan"
e.thermal_zone=t[1]
e.trip_point=t[2]
e.thermal_type=luci.util.trim(o.readfile("/sys/class/thermal/"..t[1].."/type"))
e=i:section(TypedSection,"luci-fan",translate("Fan Settings"))
e.addremove=false
e.anonymous=true
a=e:option(Flag,"enabled",translate("Enabled"),translate("Whether to apply the settings"))
a.default=0
local o=e:option(Value,"on_temp",translate("Fan start temperature").." (&#8451;)")
o.datatype="and(uinteger,min(5))"
o.rmempty=false
o.default=math.floor(tonumber(t[3])/1000)
if#t>3 then
o.datatype=string.format("and(uinteger,range(5,%u))",math.floor(tonumber(t[4])/1000-1))
end
a=e:option(Value,"off_temp",translate("Fan stop temperature").." (&#8451;)",translate("Optional, MUST be lower than the fan start temperature. Default fan start temperature minus 5 &#8451;"))
a.datatype="uinteger"
a.rmempty=true
function a.parse(e,t,s)
local a=e:formvalue(t)
local n=(a and(#a>0))
local a,i=e:validate(a)
if not a then
if s then
return
end
if n then
e:add_error(t,"invalid",i or e.title..": invalid")
return
end
end
local s=(e.rmempty or e.optional)
local i=(a and(#a>0))and true or false
local n=(a==e.default)
if s and(not i or n)then
if e:remove(t)then
e.section.changed=true
end
return
end
local i=e:cfgvalue(t)
local i=(a==i)
if not e.forcewrite and i then
return
end
local o=o:validate(o:formvalue(t))
if o and#o>0 then
if tonumber(a)>=tonumber(o)then
e:add_error(t,"invalid",translate("Fan stop temperature MUST be lower than fan start temperature"))
return
end
else
return
end
if e:write(t,a)and not i then
e.section.changed=true
end
end
return i
